// Теоретичні питання
//
//     Описати своїми словами у кілька рядків, навіщо у програмуванні потрібні цикли.
//     Опишіть у яких ситуаціях ви використовували той чи інший цикл в JS.
//     Що таке явне та неявне приведення (перетворення) типів даних у JS?
//
//     Завдання
//     Реалізувати програму на Javascript, яка знаходитиме всі числа кратні 5 (діляться на 5 без залишку) у заданому діапазоні. Завдання має бути виконане на чистому Javascript без використання бібліотек типу jQuery або React.
//
//     Технічні вимоги:
//
//     Отримати за допомогою модального вікна браузера число, яке введе користувач.
//     Вивести в консолі всі числа, кратні 5, від 0 до введеного користувачем числа. Якщо таких чисел немає - вивести в консоль фразу "Sorry, no numbers"
//     Обов'язково необхідно використовувати синтаксис ES6 (ES2015) для створення змінних.
//
//     Необов'язкове завдання підвищеної складності
//     Перевірити, чи введене значення є цілим числом. Якщо ця умова не дотримується, повторювати виведення вікна на екран, доки не буде введено ціле число.
//     Отримати два числа, m і n. Вивести в консоль усі прості числа (http://ru.math.wikia.com/wiki/%D0%9F%D1%80%D0%BE%D1%81%D1%82%D0%BE%D0%B5_%D1%87%D0%B8%D1%81%D0%BB%D0%BE) в діапазоні від m до n (менше із введених чисел буде m, більше буде n). Якщо хоча б одне з чисел не відповідає умовам валідації, зазначеним вище, вивести повідомлення про помилку і запитати обидва числа знову.
//
//// Література:  https://learn.javascript.ru/while-for

//1.Цикл потрібен для багаторазового повторення однієї й тієї ж дії
//2.Цикл for використав у першій домашній роботі для повторення дії виведення функції prompt
//        та валідації введених даних користувачем, цикл триває доки значення не стане валідним.
//3.Неявне перетворення відбувається в умовах та виразах операторів, але не всіх, наприклад оператор === не перетворює.
//        Явне перетворення коли тип задаємо оператором явного перетворення,
//              наприклад String(null) призведе до рядка 'null', а Number(false) до 0

//************************************************функції***************************************************************

//________________________функція валідації використовується і в першому, і в другому завданні__________________________

function validation(message) {
    let num                  //оголошуємо "num" до циклу для того, щоб був доступний за межами його
    for (; ;) {                   //зациклювання у вічний цикл виходитимемо за допомогою break при задоволенні умови if
        num = +prompt(message);          //message це змінна для використання у різних місцях
        if (Number.isInteger(num)) {     //Метод Number.isInteger() визначає, чи є передане значення цілим числом
            break                                            //значення валідне поїхали далі => return num
        } else alert('введене значення не є цілим числом');  //не ціле число повертаємось до питання
    }                                                         //і так далі, поки користувач не введе правильне значення
    return num;                          //функція повертає правильне значення, введене користувачем
}

//___________________________функція-перевірка на просте число для додаткового другого завдання.________________________

function primeNumber(prime) {    // повертає "1" якщо число, що перевіряється - просте і "0" якщо складене
    let j = 0                    //оголошуємо "j" до циклу для того, щоб був доступний за межами його
    for (let i = 2; i * i <= prime && j !== 1;) { //перебираємо дільники
        if (prime % i === 0) {                    //починаємо з 2 якщо залишок від розподілу дорівнює 0
            j = 1;                                //привласнюємо "j" = 1 та "i" збільшуємо на 1
            i++
        } else i++                                //якщо false просто "i" збільшуємо на 1
    }                            //і так до кінця циклу потім перевіряємо чи 'зловила' "j" одиницю
    switch (true) {
        case (prime === 0):
            return 0;            //0 => складене число в умові дасть false
        case (prime === 1):
            return 0;            //теж саме
        case (j === 1):
            return 0;            //якщо "j" 'зловила' 1 то 0 => теж false
        case !(j === 1):
            return 1;            //1 => просте в умові true
    }
}

//********************************************** перше завдання ********************************************************

const a = validation('введіть число більше 5');
if (a < 5) {                                     //в діапазоні від 0 до 5, цифри що задовольняють умові - немає
    console.log('Sorry, no numbers');
} else {
    console.log(`усі числа кратні 5 діапазону від 5 до ${a}`)
    for (let i = 5; i <= a; i++) {              //з кожною ітерацією збільшуємо num на один доки умова не стане false
        if (i % 5 === 0) console.log(i);        //в консоль виводимо тільки ті з цифр, що перераховуються,
    }                                           //залишок від поділу на 5 яких дорівнює 0
}

//********************************************** друге завдання ********************************************************

let n;                                                        //оголошуємо змінні
let m;
const firstNumber = validation('введіть перше ціле число');   //питаємо, проводимо валідацію,
const secondNumber = validation('введіть друге ціле число');  //присвоюємо введені значення допоміжним змінним
if (firstNumber < secondNumber) {        //приводимо до правильної черговості,
    m = firstNumber;                     //якщо користувач ввів перше число більше ніж останнє
    n = secondNumber;
} else {
    n = firstNumber;
    m = secondNumber;
}
(n < 2) ? console.log(`у діапазоні з ${m} по ${n} простих чисел немає, перше просте число 2`) :
          console.log(`прості числа з ${m} до ${n}`);
for (; m <= n; m++) {
    if (primeNumber(m)) console.log(m);   //перевіряємо, якщо дає істину виводимо в консоль
}




